extern void add_to_pathlist(tmdy_struct_ex_t * tmdy_struct, char *s);
extern void clean_up_pathlist(tmdy_struct_ex_t * tmdy_struct);
extern struct timidity_file *open_file(tmdy_struct_ex_t * tmdy_struct, char *name,
				       int decompress, int noise_mode);
extern struct timidity_file *open_with_mem(tmdy_struct_ex_t * tmdy_struct, char *mem, int32 memlen,
					   int noise_mode);
extern void close_file(tmdy_struct_ex_t * tmdy_struct, struct timidity_file *tf);
extern void skip(tmdy_struct_ex_t * tmdy_struct, struct timidity_file *tf, size_t len);
extern char *tf_gets(tmdy_struct_ex_t * tmdy_struct, char *buff, int n, struct timidity_file *tf);
extern long tf_read(tmdy_struct_ex_t * tmdy_struct, void *buff, int32 size, int32 nitems,
		    struct timidity_file *tf);
extern long tf_seek(tmdy_struct_ex_t * tmdy_struct, struct timidity_file *tf, long offset, int whence);
extern long tf_tell(tmdy_struct_ex_t * tmdy_struct, struct timidity_file *tf);
extern int int_rand(tmdy_struct_ex_t * tmdy_struct, int n);	/* random [0..n-1] */
extern int check_file_extension(tmdy_struct_ex_t * tmdy_struct, char *filename, char *ext, int decompress);

extern void *safe_malloc(tmdy_struct_ex_t * tmdy_struct, size_t count);
extern void *safe_realloc(tmdy_struct_ex_t * tmdy_struct, void *old_ptr, size_t new_size);
extern void *safe_large_malloc(tmdy_struct_ex_t * tmdy_struct, size_t count);
extern char *safe_strdup(tmdy_struct_ex_t * tmdy_struct, const char *s);
extern void free_ptr_list(tmdy_struct_ex_t * tmdy_struct, void *ptr_list, int count);
extern char **expand_file_archives(tmdy_struct_ex_t * tmdy_struct, char **files, int *nfiles_in_out);
extern void randomize_string_list(tmdy_struct_ex_t * tmdy_struct, char **strlist, int nstr);
extern int pathcmp(tmdy_struct_ex_t * tmdy_struct, const char *path1, const char *path2, int ignore_case);
extern void sort_pathname(tmdy_struct_ex_t * tmdy_struct, char **files, int nfiles);
extern int  load_table(tmdy_struct_ex_t * tmdy_struct, char *file);
extern char *pathsep_strrchr(tmdy_struct_ex_t * tmdy_struct, const char *path);
extern char *pathsep_strchr(tmdy_struct_ex_t * tmdy_struct, const char *path);
extern int str2mID(tmdy_struct_ex_t * tmdy_struct, char *str);

/* code:
 * "EUC"	- Extended Unix Code
 * NULL		- Auto conversion
 * "JIS"	- Japanese Industrial Standard code
 * "SJIS"	- shift-JIS code
 */
extern void code_convert(tmdy_struct_ex_t * tmdy_struct, char *in, char *out, int outsiz,
			 char *in_code, char *out_code);

extern void safe_exit(tmdy_struct_ex_t * tmdy_struct, int status);

